        ORG   00H
        LJMP  START
        CLR   EA
        LJMP  EXTINT
        NOP
        NOP
	ORG   023H
        CLR   EA
        LJMP  SERINT
        NOP

DELAY:
	MOV R1,#11H
	MOV R2,#00
D1:
        DJNZ  R2,D1
	DJNZ  R1,D1
	DJNZ  R0,DELAY
	RET

CRAM:
        MOV   A,B
        MOVX  @DPTR,A
        MOVX  A,@DPTR
        CJNE  A,B,RAMERR
        INC   DPTR
        MOV   A,#08H
        CJNE  A,DPH,CRAM
        MOV   DPTR,#0
        RET

RAMERR:
        RET

RAMT:
        MOV   DPTR,#0
        MOV   B,#00
        LCALL CRAM
        MOV   B,#055H
        LCALL CRAM
        MOV   B,#0AAH
        LCALL CRAM
        MOV   B,#0FFH
        LCALL CRAM
        RET

START:
        MOV   SP,#060H
        MOV   R7,#052H
        MOV   R0,#005H
        LCALL DELAY

;CLEAR INTERN RAM I8051 [0 - 78H]
IRAM:
        MOV   R0,#008
        MOV   R1,#078H
        MOV   @R0,#000
        INC   R0
        DJNZ  R1,IRAM

        LCALL RAMT

SERINT:
        RET

EXTINT:
        RET
        END
